=== debian/changelog ===
c4core (0.2.6-2) unstable; urgency=medium

  * Let libc4core-dev depend on debugbreak.

 -- Bastian Germann <bage@debian.org>  Tue, 06 May 2025 22:33:12 +0200

c4core (0.2.6-1) unstable; urgency=medium

  * Initial release. Closes: #1017088

 -- Bastian Germann <bage@debian.org>  Thu, 01 May 2025 07:31:06 +0000
