=== debian/control ===
Source: c4core
Section: libs
Priority: optional
Maintainer: Bastian Germann <bage@debian.org>
Build-Depends: cmake, debhelper-compat (= 13), debugbreak
Standards-Version: 4.6.2
Homepage: https://github.com/biojppm/c4core
Rules-Requires-Root: no

Package: libc4core0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: low-latency, low-level C++ library
 c4core is a library of low-level C++ utilities,
 written with low-latency projects in mind.
 .
 Some of the utilities provided by c4core have already
 equivalent functionality in the C++ standard, but they are
 provided as the existing C++ equivalent may be insufficient
 (eg, std::string_view), inefficient (eg, std::string),
 heavy (eg streams), or plainly unusable on some platforms/projects,
 (eg exceptions).
 .
 Some other utilities have equivalent under consideration for C++
 standardisation; and yet some other utilities have no equivalent
 under consideration.

Package: libc4core-dev
Architecture: any
Depends: ${misc:Depends}, libc4core0 (= ${binary:Version}), debugbreak
Section: libdevel
Description: low-latency, low-level C++ library (development files)
 c4core is a library of low-level C++ utilities,
 written with low-latency projects in mind.
 .
 Some of the utilities provided by c4core have already
 equivalent functionality in the C++ standard, but they are
 provided as the existing C++ equivalent may be insufficient
 (eg, std::string_view), inefficient (eg, std::string),
 heavy (eg streams), or plainly unusable on some platforms/projects,
 (eg exceptions).
 .
 Some other utilities have equivalent under consideration for C++
 standardisation; and yet some other utilities have no equivalent
 under consideration.
 .
 This package holds the header and development library link.
