## c4core 0.2.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 include(./cmake/c4Project.cmake)
 include(./compat.cmake)
 
-c4_project(VERSION 0.2.6
+c4_project(VERSION 0.2.7
     AUTHOR "Joao Paulo Magalhaes <dev@jpmag.me>")
 
 option(C4CORE_INSTALL "create install target" ON)
