=== bm-xp/requirements.txt ===
munch
pyyaml
py-cpuinfo
psutil
gitpython
flask
markupsafe
Frozen-Flask
requests
mmh3
numpy==1.23.1
bokeh<3.0
selenium
matplotlib
prettytable
