=== debian/changelog ===
c4core (0.2.7-1) unstable; urgency=medium

  * New upstream release
  * Adopt package (Closes: #1104864)
  * Bump Standards-Version to 4.7.2; no changes needed
  * debian/rules: enable hardening flags (hardening=+all)
  * debian/upstream/metadata: created
  * debian/copyright: updated year

 -- Gabriel Barrantes <gabriel.barrantes.dev@outlook.com>  Thu, 02 Oct 2025 22:29:47 +0000
