=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: c4core
 Section: libs
 Priority: optional
-Maintainer: Bastian Germann <bage@debian.org>
+Maintainer: Gabriel Barrantes <gabriel.barrantes.dev@outlook.com>
 Build-Depends: cmake, debhelper-compat (= 13), debugbreak
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/biojppm/c4core
 Rules-Requires-Root: no
