=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	      -DC4CORE_WITH_FASTFLOAT=OFF -DBUILD_SHARED_LIBS=SHARED
