=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%c4core-$1.tar.gz%,repacksuffix=+ds,dversionmangle=s/\+ds\d*$//" \
https://github.com/biojppm/c4core/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian

opts="component=cmake,mode=git,pretty=%cd.%h" \
https://github.com/biojppm/cmake.git \
HEAD ignore uupdate
